function c = vectorComp(vect1,vect2, method);
    vect1  = double(vect1);
    vect2 = double(vect2);
    switch method
        case 1
            %Cosine Distance
            l1 = sqrt(vect1*vect1');
            l2 = sqrt(vect2*vect2');
            c = 1 - vect1 * vect2' / (l1 * l2);
        case 2 
            %Euclidean Distance
            c = sqrt(sum((vect1 - vect2).^2));
    end
    
return;